SystemOrganization addCategory: #ConfigurationOfVisiTrait!

Object subclass: #ConfigurationOfVisiTrait
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfVisiTrait'!

!ConfigurationOfVisiTrait class methodsFor: 'development support' stamp: 'cipt 7/2/2012 19:01'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfVisiTrait class methodsFor: 'private' stamp: 'cipt 7/2/2012 19:01'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfVisiTrait class methodsFor: 'private' stamp: 'cipt 7/2/2012 19:01'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfVisiTrait class methodsFor: 'private' stamp: 'cipt 7/2/2012 19:01'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfVisiTrait class methodsFor: 'metacello tool support' stamp: 'cipt 7/2/2012 19:01'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfVisiTrait class methodsFor: 'loading' stamp: 'cipt 7/2/2012 19:01'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfVisiTrait class methodsFor: 'loading' stamp: 'cipt 7/2/2012 19:01'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfVisiTrait class methodsFor: 'loading' stamp: 'cipt 7/2/2012 19:01'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfVisiTrait class methodsFor: 'accessing' stamp: 'cipt 7/2/2012 19:01'!
project

	^self new project! !

!ConfigurationOfVisiTrait class methodsFor: 'development support' stamp: 'cipt 7/2/2012 19:01'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfVisiTrait methodsFor: 'baselines' stamp: 'cipt 7/2/2012 19:03'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VisiTrait'.
		spec 
			package: 'VisiTrait';
			package: 'VisiTrait-Examples';
			package: 'VisiTrait-Tests'.
		spec group: 'default' with: #('VisiTrait' 'VisiTrait-Examples' 'VisiTrait-Tests' ). ].
! !

!ConfigurationOfVisiTrait methodsFor: 'symbolic versions' stamp: 'cipt 7/2/2012 19:03'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfVisiTrait methodsFor: 'accessing' stamp: 'cipt 7/2/2012 19:01'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfVisiTrait methodsFor: 'versions' stamp: 'cipt 7/2/2012 19:03'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'cipt'.
		spec timestamp: '7/2/2012 19:03'.
		spec 
			package: 'VisiTrait' with: 'VisiTrait-cipt.6';
			package: 'VisiTrait-Examples' with: 'VisiTrait-Examples';
			package: 'VisiTrait-Tests' with: 'VisiTrait-Tests'. ].
! !
